Subject: bug#5582: 23.1.92; Unnecessary headings in makefile-mode imenu

From: Stefan Monnier <[email-masked]>
Date: Mon, 15 Feb 2010 14:24:09 -0500

> Severity: wishlist
> In makefile-mode, M-x imenu requires you to specify "Dependencies" or
> "Macro assignments" before you can type the name of the thing you want
> to jump to.  I think that's unnecessary, since having a macro assignment
> with the same name as a dependency is very unusual.  The patch below
> gives you a flat list instead:

> 	* progmodes/make-mode.el (makefile-imenu-generic-expression):
> 	Remove headings, turning the tree of targets into a flat list.

I agree with the goal, but I'm not sure this is the best way to
get there.  IIUC, this is a fairly common situation where there are
several namespaces, hence with potential clashes, but in practice
clashes are rare.  So, I think that the change should be made in imenu
itself to always accept an "unqualified" name and look for it in each of
the sublists.

        Stefan